clear all
close all
clc

% Funzione vera

w=linspace(-3,3,1000);
y=exp(-w.^2).*cos(8*w);

figure('unit','norm','position',[0.1 0.5 0.8 0.4])
axes('box','on','ylim',[-1.3 1.5])
hold on
line(w,y)

% Misure corrotte da rumore 

we=linspace(-3,3,50);
ye=exp(-we.^2).*cos(8*we);
d=0.02*randn(size(ye));
std(d)/std(ye)
ye=ye+d;

figure(1)
line(we,ye,'linestyle','none','marker','.','color','k')

% Identificazione

r=12;                                                 % Numero di neuroni
net=newff(minmax(we),[r 1],{'tansig' 'purelin'});     % Definizione rete neurale
net.trainparam.epochs=200;
net=train(net,we,ye);                                 % Training rete neurale sul set (we,ze)

y_net=sim(net,w);                                     % Calcolo rete neurale sul set w

figure(1)
line(w,y_net,'color','r')
