close all
clc

% Partizione dati
%------------------

% Set di identificazione:

ye=y(1:5000);
ue=u(1:5000);

% Set di validazione:

yv=y(5001:5200);
uv=u(5001:5200);

% Identificazione modello lineare
%--------------------------------

m=arx([ye' ue'],[2 1 1])
% m=oe([ye' ue'],[1 2 1])

% Validazione modello lineare
%----------------------------

% Predizione ad un passo:

yp_m=predict(m,[yv' uv']);

figure(1),hold on
plot(yv)
plot(yp_m,'r')

RMSEp_m=sqrt(mse(yv'-yp_m))

% Simulazione:

ys_m=idsim(uv',m);

figure(2),hold on
plot(yv)
plot(ys_m,'r')

RMSEs_m=sqrt(mse(yv'-ys_m))

% Identificazione NARX neurale
%------------------------------

Ne=length(ye);

for t=2:Ne-1
    phie(:,t)=[ye(t);ye(t-1);ue(t)];
    ze(t)=ye(t+1);
end

nn=newff(minmax(phie),[8 1],{'tansig' 'purelin'});
nn.trainparam.epochs=100;
nn=train(nn,phie,ze);

% Validazione NARX neurale
%--------------------------

Nv=length(yv);

% Predizione ad un passo:

yp_nn(1:2)=yv(1:2);
for t=2:Nv-1
    phiv=[yv(t);yv(t-1);uv(t)];
    yp_nn(t+1)=sim(nn,phiv);
end

figure(1),hold on
plot(yv,'b')
plot(yp_nn,'g')

RMSEp_nn=sqrt(mse(yv-yp_nn))

% Simulazione:

ys_nn(1:2)=[0 0];
for t=2:Nv-1
    phiv=[ys_nn(t);ys_nn(t-1);uv(t)];
    ys_nn(t+1)=sim(nn,phiv);
end

figure(2),hold on
plot(yv,'b')
plot(ys_nn,'g')

RMSEp_nn=sqrt(mse(yv-ys_nn))


